const clients = {};
export default async function useSanityClient(visualEditing, type, config) {
  const clientType = visualEditing ? "default" : type;
  if (clientType in clients) return clients[clientType];
  const clientConfig = {
    ...config,
    stega: visualEditing && config.stega
  };
  const client = new (await (clientType === "minimal" ? import("../client/MinimalSanityClient") : import("../client/DefaultSanityClient"))).default(clientConfig);
  if (visualEditing) client.createQueryStore();
  clients[clientType] = client;
  return client;
}
