import { defineEncodeDataAttribute } from "@sanity/core-loader/encode-data-attribute";
export async function fetchSanityData(query, params, client, perspective, callback) {
  function updateResult(data2, sourceMap2) {
    const encodeDataAttribute = sourceMap2 ? defineEncodeDataAttribute(data2, sourceMap2, client.config.visualEditing?.studioUrl) : void 0;
    callback(data2, sourceMap2, encodeDataAttribute);
  }
  const defaultClient = client;
  const proxyClient = {
    fetch: (query2, params2, options) => $fetch(client.config.visualEditing.proxyEndpoint || "/_sanity/fetch", {
      method: "POST",
      body: { query: query2, params: params2, options }
    })
  };
  const currentClient = import.meta.server ? defaultClient.queryStore.unstable__serverClient.instance || defaultClient.client : proxyClient;
  const { result: data, resultSourceMap: sourceMap } = await currentClient.fetch(query, params || {}, {
    perspective,
    filterResponse: false,
    resultSourceMap: "withKeyArraySelector"
  });
  updateResult(data, sourceMap);
}
